package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.entity.Dead;
import com.lantone.qc.pub.model.entity.Family;
import com.lantone.qc.pub.model.label.FamilyLabel;
import com.lantone.qc.pub.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @ClassName : BEH0072
 * @Description : 家属有死亡者,未记录死亡原因及年龄
 * @Author : 胡敬
 * @Date: 2020-03-11 16:44
 */
@Component
public class BEH0072 extends QCCatalogue {
    @Override
    protected void start(InputInfo inputInfo, OutputInfo outputInfo) {
        if (inputInfo.getBeHospitalizedDoc() != null && inputInfo.getBeHospitalizedDoc().getFamilyLabel() != null) {
            FamilyLabel familyLabel = inputInfo.getBeHospitalizedDoc().getFamilyLabel();
            List<Family> families = familyLabel.getFamilies();
            int deadObjectNum = 0;
            for (Family family : families) {
                if (family.getDead() == null) {
                    deadObjectNum++;
                } else {
                    Dead dead = family.getDead();
                    if ((dead.getDeadReason() != null && StringUtil.isNotBlank(dead.getDeadReason().getName())
                            || (dead.getUnknow() != null && StringUtil.isNotBlank(dead.getUnknow().getName())))) {
                        status.set("0");
                        return;
                    }
                }
            }
            if (deadObjectNum == families.size()){
                status.set("0");
            }
        }
    }
}